; <--- description --->
; compiler:     FASM 1.65
; name:         Basic window example with kxWidget
; version:      0.1
; last update:  23/07/2006
; written by:   Frank Sommer
; e-mail:       derPENGUIN@lightstormradio.de

; <--- include all MeOS stuff --->
include "MACROS.INC"
include "KXDEFS.INC"
include "KXDIALOG.INC"

purge mov   ; increase speed, but also size

; <--- start of MenuetOS application --->
MEOS_APP_START

; <--- start of code --->
CODE
    mcall   40,100111b
    mcall	66,1,0
    call    init_window
    call    draw_window 	   ; at first create and draw the window

  wait_event:			   ; main cycle
    mcall   10
    cmp     eax, 1		   ;   if event == 1
    je	    redraw		   ;     jump to redraw handler
    cmp     eax, 3		   ;   else if event == 3
    je	    button		   ;     jump to button handler
    cmp     eax,6		   ;   else if event == 6
    je	    mouse		   ;      jump to mouse handlere
    cmp     eax, 2		   ;   else if event == 2
    je	    key 		   ;     jump to key handler
    jmp     wait_event		   ;   else return to the start of main cycle

  redraw:			   ; redraw event handler
    call    draw_window
    jmp     wait_event

  key:				   ; key event handler
    mcall   2			   ;   get key code
;    cmp                        al,1
;    je                 wait_event
    call    k_event_hnd     ;                       this is the kxDialog event handler for keys
    call    redraw
    jmp     wait_event

  mouse:			   ; todo
    jmp     wait_event

  button:			   ; button event handler
    mcall   17		      ;   get button identifier
    call    b_event_hnd       ;   this is the kxDialog event handler for buttons

; this is done in kxEvent
;    cmp     ah, 1
;    jne     no_close
;    mcall   -1                ;   exit application

  no_close:                    ; dont change the name of this label!!!

  btn2:
    cmp     ah, byte [btnInfo.id]	      ;   show info button pressed?
    jne     cbx1
  cbx1:
    cmp     ah, byte [cbxTest1.id]	      ;   checkbox 1 pressed?
    jne     cbx2
    jmp     switch_bstyle1
  cbx2:
    cmp     ah, byte [cbxTest2.id]	      ;   checkbox 2 pressed?
    jne     nothing
    jmp     switch_bstyle2

switch_bstyle1:
    xor [bvl1.bstyle],bsOuter
    jmp nothing

switch_bstyle2:
    xor [bvl2.bstyle],bsOuter

  nothing:
    call    redraw
    jmp     wait_event


;-------------------------------------------------------------------------------
  init_window:		      ; here we declare and init all used widgets
    kxNew kxWindow,frmMain
    kxNew kxLabel,lbl1
    kxNew kxLabel,lbl2
    kxNew kxULabel,lbl3
    kxNew kxULabel,lbl4
    kxNew kxBevel,bvl1
    kxNew kxBevel,bvl2
    kxNew kxListbox,lbx1
    kxNew kxCheckbox,cbxTest1
    kxNew kxCheckbox,cbxTest2
    kxNew kxButton,btnInfo
    kxNew kxButton,btnOK

    or [btnOK.focustab],hasFocus    ; we can give one widget the focus at start
  ret

  draw_window:
    mcall   12,1		   ; start drawing

      mov [frmMain.caption],msg_frmCaption
      mov [frmMain.xsize],600
      mov [frmMain.ysize],500
      mov [frmMain.xpos],100
      mov [frmMain.ypos],60
      mov [frmMain.bcolor],clWindow or wsNormal ; bg color and style
      mov [frmMain.ccolor],clLime or fsBold    ; caption color
    kxDraw frmMain,_kxWindow,msg_frmCaption.size

    call   lgfunc	 ; include graphic funktions, but not before
			 ; we have a window

      mov [lbl1.caption],msg_lbl1
      mov [lbl1.xpos],20
      mov [lbl1.ypos],30
      mov [lbl1.ccolor],clBlack
    kxDraw lbl1,_kxLabel,msg_lbl1.size;10

      mov [lbl2.caption],msg_lbl2
      mov [lbl2.xpos],20
      mov [lbl2.ypos],40
      mov [lbl2.ccolor],clBlack
    kxDraw lbl2,_kxLabel,msg_lbl2.size;10

      mov [lbl3.caption],msg_lbl3
      mov [lbl3.xpos],110
      mov [lbl3.ypos],40
      mov [lbl3.ccolor],clBlue
    kxDraw lbl3,_kxULabel,msg_lbl3.size;12

      mov [lbl4.caption],msg_lbl4
      mov [lbl4.xpos],60
      mov [lbl4.ypos],80
      mov [lbl4.ccolor],clBlack or fsBold
    kxDraw lbl4,_kxULabel,msg_lbl4.size;12

      mov [cbxTest1.caption],msg_cbx1
      mov [cbxTest1.xpos],50
      mov [cbxTest1.ypos],110
      mov [cbxTest1.ccolor],clBlack
      mov [cbxTest1.id],word 10
      or [cbxTest1.focustab],canFocus	     ; widget can get the focus
;      mov [cbxTest1.checked],TRUE
    kxDraw cbxTest1,_kxCheckbox,msg_cbx1.size;60

      mov [cbxTest2.caption],msg_cbx2
      mov [cbxTest2.xpos],50
      mov [cbxTest2.ypos],125
      mov [cbxTest2.ccolor],clBlack
      mov [cbxTest2.id],word 11
      or [cbxTest2.focustab],canFocus	     ; widget can get the focus
    kxDraw cbxTest2,_kxCheckbox,msg_cbx2.size;60

      mov [bvl1.xsize],540
      mov [bvl1.ysize],350
      mov [bvl1.xpos],30
      mov [bvl1.ypos],60
      mov [bvl1.bsize],3		; border size, try size 0
;      mov [bvl1.bstyle],bsInner         ; bevel style, try bsOuter
    kxDraw bvl1,_kxBevel,0;20      ; the 0 is for string length, but we have no caption atm

      mov [bvl2.xsize],250
      mov [bvl2.ysize],75
      mov [bvl2.xpos],40
      mov [bvl2.ypos],70
      mov [bvl2.bsize],0
;      mov [bvl2.bstyle],bsOuter
    kxDraw bvl2,_kxBevel,0;20

      mov [btnOK.caption],msg_ok
      mov [btnOK.xpos],40
      mov [btnOK.ypos],450
      mov [btnOK.xsize],60
      mov [btnOK.ysize],20
      mov [btnOK.bcolor],clWindow
      mov [btnOK.ccolor],clRed or fsBold
      mov [btnOK.id],1
      or [btnOK.focustab],canFocus	  ; widget can get the focus
    kxDraw btnOK,_kxButton,msg_ok.size;50

      mov [btnInfo.caption],msg_info	; show info butto
      mov [btnInfo.xpos],420
      mov [btnInfo.ypos],170
      mov [btnInfo.xsize],70
      mov [btnInfo.ysize],30
      mov [btnInfo.bcolor],clButton
      mov [btnInfo.ccolor],clBlue
      mov [btnInfo.id], 3
; for this widget we disallow focus for testing      
;      or [btnInfo.focustab],canFocus	    ; widget can get the focus
    kxDraw btnInfo,_kxButton,msg_info.size;50

      mov [lbx1.xsize],150
;      mov [lbx1.ysize],14              ; not used
      mov [lbx1.xpos],50
      mov [lbx1.ypos],160
      mov [lbx1.bcolor],0xffffcc
      mov [lbx1.id],20
    kxDraw lbx1,_kxListbox,0;70

; mcall 8,<20,50>,<60,20>,,clWindow
; mov eax,[woff]
; mov [wp],eax
; mcall 47,16*65536+10,[dbg],60*65536+190,clRed
; mcall 47,16*65536+10,[dbg2],60*65536+200,0
; mcall 47,16*65536+10,[dbg],60*65536+210,0
 mcall 47,32*65536+512,[644+32],60*65536+220,0

; mcall 4,<20,40>,0,msg_ok,msg_ok.size
    mcall   12,2		   ; finish drawing
  ret


;-------------------------------------------------------------------------------
; include graphic functions
func lgfunc
    include "KXGFUNC.INC"
    ret
endf
;-------------------------------------------------------------------------------


; <--- initialised data --->
DATA

  lsz msg_ok,en,"Close"
  lsz msg_info,en,"show info"
  lsz msg_lbl1,en,"This is a sample application with kxWidgets."
  lsz msg_lbl2,en,"We can draw an "
  lsz msg_lbl3,en,"underlined label!"
  lsz msg_lbl4,en,"Test here different bevel styles"
  lsz msg_cbx1,en,"Select bevel style 1 or 2"
  lsz msg_cbx2,en,"Select bevel style 3 or 4"
  lsz msg_frmCaption,en,"kxWidget Sample Application"

  include "KXDATA.INC"	   ; kxDialog data definitions include here
; <--- uninitialised data --->
UDATA


MEOS_APP_END
; <--- end of MenuetOS application --->
